unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls;

type
   TPlanetThread = class(TThread)
   private

     r,angv,ang:real;
     color:TColor;
     position:TPoint;
   public
    constructor create;overload;
    constructor create(r,angv:real;color:TColor);overload;
    procedure Execute;override;
    procedure movePlanet;
   end;

  TForm1 = class(TForm)
    Image1: TImage;
    MainMenu1: TMainMenu;
    Planety1: TMenuItem;
    Start1: TMenuItem;
    Pause1: TMenuItem;
    Exit1: TMenuItem;
    Settings1: TMenuItem;
    procedure Settings1Click(Sender: TObject);
    procedure Start1Click(Sender: TObject);
    procedure Pause1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    planets:array [1..4] of TPlanetThread;
    { Private declarations }
  public
    procedure drawPlanets;
    procedure hidePlanets;
{ Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

 constructor TPlanetThread.create;
 begin
  inherited create(true);
  r:=100;
  color:=clNone;
  angv:=1/10;
  ang:=0;
  position.X:=Form1.Image1.width div 2 + round(r*cos(ang));
  position.Y:=Form1.Image1.height div 2 + round(r*sin(ang));
  Form1.drawPlanets;
 end;

 constructor TPlanetThread.create(r,angv:Real;color:TColor);
 begin
  inherited create(true);
  self.r:=r;
  self.angv := angv;
  self.color:=color;
  ang:=0;
  position.X:=Form1.Image1.width div 2 + round(r*cos(ang));
  position.Y:=Form1.Image1.height div 2 + round(r*sin(ang));
 end;

 procedure TPlanetThread.Execute;
 begin
   while not Terminated do
   begin
     ang:=ang + Pi*angv/100;
     synchronize(movePlanet);
     sleep(10);
   end;
 end;

 procedure TPlanetThread.movePlanet;
 begin
  Form1.hidePlanets;
  position.X:=Form1.Image1.width div 2 +round(r*cos(ang));
  position.Y:=Form1.Image1.height div 2 +round(r*sin(ang));
  Form1.drawPlanets;
 end;


 procedure TForm1.drawPlanets;
 var i:integer;
 begin
  for i:= 1 to 4 do
  begin
   Image1.Canvas.Pen.Color:=Planets[i].color;
   Image1.Canvas.Brush.Color:=Planets[i].color;
   Image1.Canvas.Ellipse(planets[i].position.X -3,
                         planets[i].position.Y - 3,
                         planets[i].position.X + 3,
                         planets[i].position.Y +3);

  end;
 end;

 procedure TForm1.hidePlanets;
 var i:integer;
 begin
  for i:= 1 to 4 do
  begin
   Image1.Canvas.Pen.Color:=clWhite;
   Image1.Canvas.Brush.Color:=clWhite;
   Image1.Canvas.Ellipse(planets[i].position.X -3,
                         planets[i].position.Y - 3,
                         planets[i].position.X + 3,
                         planets[i].position.Y +3);
  end;
 end;


{$R *.dfm}

procedure TForm1.Settings1Click(Sender: TObject);
begin
 if form2.showmodal = mrOk then
 begin
  Start1.Enabled := true;
  planets[1]:=TPlanetThread.create((image1.height div 2)div 5,(form2.combobox1.itemindex+1)*0.1,clRed);
  planets[2]:=TPlanetThread.create((image1.height div 2)div 5 *2,(form2.combobox2.itemindex+1)*0.1,clGreen);
  planets[3]:=TPlanetThread.create((image1.height div 2)div 5 *3,(form2.combobox3.itemindex+1)*0.1,clBlue);
  planets[4]:=TPlanetThread.create((image1.height div 2)div 5 *4,(form2.combobox4.itemindex+1)*0.1,clBlack);
  drawPlanets;
 end;
end;


procedure TForm1.Start1Click(Sender: TObject);
var i:integer;
begin
 pause1.Enabled:=true;
 for i:=1 to 4 do
  planets[i].Resume;
 start1.Enabled:=false;
end;



procedure TForm1.Pause1Click(Sender: TObject);
var i:integer;
begin
 if(Pause1.Checked) then
   for i:=1 to 4 do
    planets[i].resume
  else for i:=1 to 4 do planets[i].suspend;
 Pause1.Checked:= not Pause1.Checked;

end;


procedure TForm1.FormCreate(Sender: TObject);
var centerx,centery:integer;
begin
 Start1.Enabled := false;
 Pause1.Enabled := false;
 Pause1.Checked := false;
 Image1.Canvas.Pen.Color:=clYellow;
 centerx:=Image1.Width div 2;
 centery:=Image1.Height div 2;
 image1.Canvas.Brush.Color:=clYellow;
 Image1.Canvas.Brush.Style:=bsSolid;
 image1.Canvas.Ellipse(centerx-20,centery-20,centerx+20,centery+20);
 Image1.Canvas.Brush.Color:=clWhite;
{ Image1.Canvas.Brush.Style:=bsClear;}
end;

procedure TForm1.Exit1Click(Sender: TObject);
var i:integer;
begin
 Application.Terminate;
end;

end.

